<html>
<head>
<title>OgreAtomicWrappers.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreAtomicWrappers.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreAtomicWrappers_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _AtomicWrapper_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _AtomicWrapper_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;signal.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00043"></a><a class="code" href="classOgre_1_1AtomicObject.html">00043</a>     <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1AtomicObject.html">AtomicObject</a> {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045         <span class="keyword">public</span>:
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classOgre_1_1AtomicObject.html#a1a735a151b7c9e97b3095ce59f3fb35f">00047</a>         <a class="code" href="classOgre_1_1AtomicObject.html#afddc516687dc1689a52799d392314ac7">AtomicObject</a> (<span class="keyword">const</span> T &amp;initial)
<a name="l00048"></a>00048             : <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>(initial)
<a name="l00049"></a>00049         {   }
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classOgre_1_1AtomicObject.html#a140023f984d7c31ce54cedfeea8e52f4">00051</a>         <a class="code" href="classOgre_1_1AtomicObject.html#afddc516687dc1689a52799d392314ac7">AtomicObject</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1AtomicObject.html">AtomicObject&lt;T&gt;</a> &amp;cousin)
<a name="l00052"></a>00052             : <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>(cousin.<a class="code" href="classOgre_1_1AtomicObject.html#a6a0ec9d4641d7ad76556dce12dcc389b">get</a>())
<a name="l00053"></a>00053         {   }
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classOgre_1_1AtomicObject.html#afddc516687dc1689a52799d392314ac7">00055</a>         <a class="code" href="classOgre_1_1AtomicObject.html#afddc516687dc1689a52799d392314ac7">AtomicObject</a> ()
<a name="l00056"></a>00056         {   }
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classOgre_1_1AtomicObject.html#a8a364f1b9caf8e6370cf934df98d2b65">00058</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AtomicObject.html#a8a364f1b9caf8e6370cf934df98d2b65">operator= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AtomicObject.html">AtomicObject&lt;T&gt;</a> &amp;cousin)
<a name="l00059"></a>00059         {
<a name="l00060"></a>00060             <span class="keyword">set</span>(cousin.<a class="code" href="classOgre_1_1AtomicObject.html#a6a0ec9d4641d7ad76556dce12dcc389b">get</a>());
<a name="l00061"></a>00061         }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classOgre_1_1AtomicObject.html#a6a0ec9d4641d7ad76556dce12dcc389b">00063</a>         T <span class="keyword">get</span> (void) <span class="keyword">const</span>
<a name="l00064"></a>00064         {
<a name="l00065"></a>00065             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00066"></a>00066             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>;
<a name="l00067"></a>00067         }
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classOgre_1_1AtomicObject.html#a9e26319c6463bb3c6fc7a1fbd41371ae">00069</a>         <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> T &amp;v)
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00072"></a>00072             <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a> = v;
<a name="l00073"></a>00073         }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classOgre_1_1AtomicObject.html#a1b10b36d617340e20ad8bb4cde753624">00075</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AtomicObject.html#a1b10b36d617340e20ad8bb4cde753624">cas</a> (<span class="keyword">const</span> T &amp;old, <span class="keyword">const</span> T &amp;nu)
<a name="l00076"></a>00076         {
<a name="l00077"></a>00077             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00078"></a>00078             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a> != old) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00079"></a>00079             <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a> = nu;
<a name="l00080"></a>00080             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00081"></a>00081         }
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classOgre_1_1AtomicObject.html#ab25c34a298a2e309bc3b5289dd77a920">00083</a>         T <a class="code" href="classOgre_1_1AtomicObject.html#ab25c34a298a2e309bc3b5289dd77a920">operator++ </a>(<span class="keywordtype">void</span>)
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00086"></a>00086             <span class="keywordflow">return</span> ++<a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>;
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classOgre_1_1AtomicObject.html#a270b27b1ae5c86ea245abb600c1fe6a4">00089</a>         T <a class="code" href="classOgre_1_1AtomicObject.html#ab25c34a298a2e309bc3b5289dd77a920">operator++ </a>(<span class="keywordtype">int</span>)
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00092"></a>00092             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>++;
<a name="l00093"></a>00093         }
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classOgre_1_1AtomicObject.html#a522c27e085a3ed54877a55749c1ed234">00095</a>         T <a class="code" href="classOgre_1_1AtomicObject.html#a522c27e085a3ed54877a55749c1ed234">operator-- </a>(<span class="keywordtype">int</span>)
<a name="l00096"></a>00096         {
<a name="l00097"></a>00097             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00098"></a>00098             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>--;
<a name="l00099"></a>00099         }
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classOgre_1_1AtomicObject.html#a9aabeb9790ae20baf90b4447626436de">00101</a>         T <a class="code" href="classOgre_1_1AtomicObject.html#a9aabeb9790ae20baf90b4447626436de">operator+=</a>(<span class="keyword">const</span> T &amp;add)
<a name="l00102"></a>00102         {
<a name="l00103"></a>00103             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00104"></a>00104             <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a> += add;
<a name="l00105"></a>00105             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>;
<a name="l00106"></a>00106         }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108         <span class="keyword">protected</span>:
<a name="l00109"></a>00109 
<a name="l00110"></a>00110         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">00112</a>         <span class="keyword">volatile</span> T <a class="code" href="classOgre_1_1AtomicObject.html#ac7c144351c2178e0401c34c2bbd31680">mField</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     };
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#if (((OGRE_COMPILER == OGRE_COMPILER_GNUC) &amp;&amp; (OGRE_COMP_VER &gt;= 412)) || (OGRE_COMPILER == OGRE_COMPILER_CLANG)) &amp;&amp; OGRE_THREAD_SUPPORT</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
<a name="l00122"></a>00122 <span class="keyword">namespace </span>Ogre {
<a name="l00123"></a>00123 
<a name="l00130"></a>00130     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span>AtomicScalar
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132 
<a name="l00133"></a>00133         <span class="keyword">public</span>:
<a name="l00134"></a>00134 
<a name="l00135"></a>00135         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> (<span class="keyword">const</span> T &amp;initial)
<a name="l00136"></a>00136             : <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>(initial)
<a name="l00137"></a>00137         {   }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> (<span class="keyword">const</span> AtomicScalar&lt;T&gt; &amp;cousin)
<a name="l00140"></a>00140             : <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>(cousin.<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>)
<a name="l00141"></a>00141         {   }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> () 
<a name="l00144"></a>00144         {   }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AtomicScalar.html#add12daab3ff51fa24089269ab93100a5">operator= </a>(<span class="keyword">const</span> AtomicScalar&lt;T&gt; &amp;cousin)
<a name="l00147"></a>00147         {
<a name="l00148"></a>00148             <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a> = cousin.mField;
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151         T <span class="keyword">get</span> (void) <span class="keyword">const</span>
<a name="l00152"></a>00152         {
<a name="l00153"></a>00153             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00154"></a>00154         }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156         <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> T &amp;v)
<a name="l00157"></a>00157         {
<a name="l00158"></a>00158             <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a> = v; 
<a name="l00159"></a>00159         }   
<a name="l00160"></a>00160 
<a name="l00161"></a>00161         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">cas</a> (<span class="keyword">const</span> T &amp;old, <span class="keyword">const</span> T &amp;nu)
<a name="l00162"></a>00162         {
<a name="l00163"></a>00163             <span class="keywordflow">return</span> __sync_bool_compare_and_swap (&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, old, nu);
<a name="l00164"></a>00164         }
<a name="l00165"></a>00165             
<a name="l00166"></a>00166         T <a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++ </a>(<span class="keywordtype">void</span>)
<a name="l00167"></a>00167         {
<a name="l00168"></a>00168             __sync_add_and_fetch (&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, 1);
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170             
<a name="l00171"></a>00171         T <a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator-- </a>(<span class="keywordtype">void</span>)
<a name="l00172"></a>00172         {
<a name="l00173"></a>00173             __sync_add_and_fetch (&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, -1);
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176         T <a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++ </a>(<span class="keywordtype">int</span>)
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178             __sync_fetch_and_add (&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, 1);
<a name="l00179"></a>00179         }
<a name="l00180"></a>00180             
<a name="l00181"></a>00181         T <a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator-- </a>(<span class="keywordtype">int</span>)
<a name="l00182"></a>00182         {
<a name="l00183"></a>00183             __sync_fetch_and_add (&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, -1);
<a name="l00184"></a>00184         }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186         T <a class="code" href="classOgre_1_1AtomicScalar.html#a582c7e533ac3485ca23d206a259b2860">operator+=</a>(<span class="keyword">const</span> T &amp;add)
<a name="l00187"></a>00187         {
<a name="l00188"></a>00188             <span class="keywordflow">return</span> __sync_add_and_fetch (&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, add);
<a name="l00189"></a>00189         }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191         <span class="keyword">volatile</span> T <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193     };
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="preprocessor"> #elif OGRE_COMPILER == OGRE_COMPILER_MSVC &amp;&amp; OGRE_COMP_VER &gt;= 1400 &amp;&amp; OGRE_THREAD_SUPPORT</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span>
<a name="l00201"></a>00201 <span class="preprocessor">#ifndef WIN32_LEAN_AND_MEAN</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span><span class="preprocessor">#  define WIN32_LEAN_AND_MEAN</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span><span class="preprocessor">#if !defined(NOMINMAX) &amp;&amp; defined(_MSC_VER)</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span><span class="preprocessor">#   define NOMINMAX // required to stop windows.h messing up std::min</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span><span class="preprocessor">#include &lt;windows.h&gt;</span>
<a name="l00208"></a>00208 <span class="preprocessor">#include &lt;intrin.h&gt;</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="keyword">namespace </span>Ogre {
<a name="l00211"></a>00211 
<a name="l00218"></a>00218     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span>AtomicScalar
<a name="l00219"></a>00219     {
<a name="l00220"></a>00220 
<a name="l00221"></a>00221         <span class="keyword">public</span>:
<a name="l00222"></a>00222 
<a name="l00223"></a>00223         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> (<span class="keyword">const</span> T &amp;initial)
<a name="l00224"></a>00224             : <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>(initial)
<a name="l00225"></a>00225         {   }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> (<span class="keyword">const</span> AtomicScalar&lt;T&gt; &amp;cousin)
<a name="l00228"></a>00228             : <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>(cousin.<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>)
<a name="l00229"></a>00229         {   }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> () 
<a name="l00232"></a>00232         {   }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AtomicScalar.html#add12daab3ff51fa24089269ab93100a5">operator= </a>(<span class="keyword">const</span> AtomicScalar&lt;T&gt; &amp;cousin)
<a name="l00235"></a>00235         {
<a name="l00236"></a>00236             <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a> = cousin.mField;
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239         T <span class="keyword">get</span> (void) <span class="keyword">const</span>
<a name="l00240"></a>00240         {
<a name="l00241"></a>00241             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00242"></a>00242         }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244         <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> T &amp;v)
<a name="l00245"></a>00245         {
<a name="l00246"></a>00246             <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a> = v;
<a name="l00247"></a>00247         }   
<a name="l00248"></a>00248 
<a name="l00249"></a>00249         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">cas</a> (<span class="keyword">const</span> T &amp;old, <span class="keyword">const</span> T &amp;nu)
<a name="l00250"></a>00250         {
<a name="l00251"></a>00251             <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==2) {
<a name="l00252"></a>00252                 <span class="keywordflow">return</span> _InterlockedCompareExchange16((SHORT*)&amp;<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>, static_cast&lt;SHORT&gt;(nu), static_cast&lt;SHORT&gt;(old)) == <span class="keyword">static_cast&lt;</span>SHORT<span class="keyword">&gt;</span>(old);
<a name="l00253"></a>00253             } 
<a name="l00254"></a>00254             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==4) 
<a name="l00255"></a>00255             {
<a name="l00256"></a>00256                 <span class="keywordflow">return</span> _InterlockedCompareExchange((LONG*)&amp;mField, static_cast&lt;LONG&gt;(nu), static_cast&lt;LONG&gt;(old)) == <span class="keyword">static_cast&lt;</span>LONG<span class="keyword">&gt;</span>(old);
<a name="l00257"></a>00257             } 
<a name="l00258"></a>00258             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==8) {
<a name="l00259"></a>00259                 <span class="keywordflow">return</span> _InterlockedCompareExchange64((LONGLONG*)&amp;mField, static_cast&lt;LONGLONG&gt;(nu), static_cast&lt;LONGLONG&gt;(old)) == <span class="keyword">static_cast&lt;</span>LONGLONG<span class="keyword">&gt;</span>(old);
<a name="l00260"></a>00260             } 
<a name="l00261"></a>00261             <span class="keywordflow">else</span> {
<a name="l00262"></a>00262                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>,<span class="stringliteral">&quot;Only 16, 32, and 64 bit scalars supported in win32.&quot;</span>,<span class="stringliteral">&quot;AtomicScalar::cas&quot;</span>);
<a name="l00263"></a>00263             }
<a name="l00264"></a>00264         }
<a name="l00265"></a>00265             
<a name="l00266"></a>00266         T <a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++ </a>(<span class="keywordtype">void</span>)
<a name="l00267"></a>00267         {
<a name="l00268"></a>00268             <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==2) {
<a name="l00269"></a>00269                 <span class="keywordflow">return</span> InterlockedIncrement16((SHORT*)&amp;mField);
<a name="l00270"></a>00270             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==4) {
<a name="l00271"></a>00271                 <span class="keywordflow">return</span> InterlockedIncrement((LONG*)&amp;mField);
<a name="l00272"></a>00272             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==8) {
<a name="l00273"></a>00273                 <span class="keywordflow">return</span> InterlockedIncrement64((LONGLONG*)&amp;mField);
<a name="l00274"></a>00274             } <span class="keywordflow">else</span> {
<a name="l00275"></a>00275                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>,<span class="stringliteral">&quot;Only 16, 32, and 64 bit scalars supported in win32.&quot;</span>,<span class="stringliteral">&quot;AtomicScalar::operator++(prefix)&quot;</span>);
<a name="l00276"></a>00276             }
<a name="l00277"></a>00277         }
<a name="l00278"></a>00278             
<a name="l00279"></a>00279         T <a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator-- </a>(<span class="keywordtype">void</span>)
<a name="l00280"></a>00280         {
<a name="l00281"></a>00281             <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==2) {
<a name="l00282"></a>00282                 <span class="keywordflow">return</span> InterlockedDecrement16((SHORT*)&amp;mField);
<a name="l00283"></a>00283             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==4) {
<a name="l00284"></a>00284                 <span class="keywordflow">return</span> InterlockedDecrement((LONG*)&amp;mField);
<a name="l00285"></a>00285             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==8) {
<a name="l00286"></a>00286                 <span class="keywordflow">return</span> InterlockedDecrement64((LONGLONG*)&amp;mField);
<a name="l00287"></a>00287             } <span class="keywordflow">else</span> {
<a name="l00288"></a>00288                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>,<span class="stringliteral">&quot;Only 16, 32, and 64 bit scalars supported in win32.&quot;</span>,<span class="stringliteral">&quot;AtomicScalar::operator--(prefix)&quot;</span>);
<a name="l00289"></a>00289             }
<a name="l00290"></a>00290         }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292         T <a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++ </a>(<span class="keywordtype">int</span>)
<a name="l00293"></a>00293         {
<a name="l00294"></a>00294             <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==2) {
<a name="l00295"></a>00295                 <span class="keywordflow">return</span> InterlockedIncrement16((SHORT*)&amp;mField)-1;
<a name="l00296"></a>00296             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==4) {
<a name="l00297"></a>00297                 <span class="keywordflow">return</span> InterlockedIncrement((LONG*)&amp;mField)-1;
<a name="l00298"></a>00298             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==8) {
<a name="l00299"></a>00299                 <span class="keywordflow">return</span> InterlockedIncrement64((LONGLONG*)&amp;mField)-1;
<a name="l00300"></a>00300             } <span class="keywordflow">else</span> {
<a name="l00301"></a>00301                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>,<span class="stringliteral">&quot;Only 16, 32, and 64 bit scalars supported in win32.&quot;</span>,<span class="stringliteral">&quot;AtomicScalar::operator++(postfix)&quot;</span>);
<a name="l00302"></a>00302             }
<a name="l00303"></a>00303         }
<a name="l00304"></a>00304             
<a name="l00305"></a>00305         T <a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator-- </a>(<span class="keywordtype">int</span>)
<a name="l00306"></a>00306         {
<a name="l00307"></a>00307             <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==2) {
<a name="l00308"></a>00308                 <span class="keywordflow">return</span> InterlockedDecrement16((SHORT*)&amp;mField)+1;
<a name="l00309"></a>00309             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==4) {
<a name="l00310"></a>00310                 <span class="keywordflow">return</span> InterlockedDecrement((LONG*)&amp;mField)+1;
<a name="l00311"></a>00311             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<span class="keyword">sizeof</span>(T)==8) {
<a name="l00312"></a>00312                 <span class="keywordflow">return</span> InterlockedDecrement64((LONGLONG*)&amp;mField)+1;
<a name="l00313"></a>00313             } <span class="keywordflow">else</span> {
<a name="l00314"></a>00314                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>,<span class="stringliteral">&quot;Only 16, 32, and 64 bit scalars supported in win32.&quot;</span>,<span class="stringliteral">&quot;AtomicScalar::operator--(postfix)&quot;</span>);
<a name="l00315"></a>00315             }
<a name="l00316"></a>00316         }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318         T <a class="code" href="classOgre_1_1AtomicScalar.html#a582c7e533ac3485ca23d206a259b2860">operator+=</a>(<span class="keyword">const</span> T &amp;add)
<a name="l00319"></a>00319         {
<a name="l00320"></a>00320             <span class="comment">//The function InterlockedExchangeAdd is not available for 64 and 16 bit version</span>
<a name="l00321"></a>00321             <span class="comment">//We will use the cas operation instead. </span>
<a name="l00322"></a>00322             T newVal;
<a name="l00323"></a>00323             <span class="keywordflow">do</span> {
<a name="l00324"></a>00324                 <span class="comment">//Create a value of the current field plus the added value</span>
<a name="l00325"></a>00325                 newVal = mField + add;
<a name="l00326"></a>00326                 <span class="comment">//Replace the current field value with the new value. Ensure that the value </span>
<a name="l00327"></a>00327                 <span class="comment">//of the field hasn&#39;t changed in the mean time by comparing it to the new value</span>
<a name="l00328"></a>00328                 <span class="comment">//minus the added value. </span>
<a name="l00329"></a>00329             } <span class="keywordflow">while</span> (!<a class="code" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">cas</a>(newVal - add, newVal)); <span class="comment">//repeat until successful</span>
<a name="l00330"></a>00330             <span class="keywordflow">return</span> newVal;
<a name="l00331"></a>00331         }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333         <span class="keyword">volatile</span> T <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00334"></a>00334 
<a name="l00335"></a>00335     };
<a name="l00339"></a>00339 }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="preprocessor">#else</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span>
<a name="l00343"></a>00343 <span class="keyword">namespace </span>Ogre {
<a name="l00344"></a>00344 
<a name="l00351"></a><a class="code" href="classOgre_1_1AtomicScalar.html">00351</a>     <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a> {
<a name="l00352"></a>00352 
<a name="l00353"></a>00353         <span class="keyword">public</span>:
<a name="l00354"></a>00354 
<a name="l00355"></a><a class="code" href="classOgre_1_1AtomicScalar.html#ab5c4f1a0732ba493f63d9f05b2064d39">00355</a>         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> (<span class="keyword">const</span> T &amp;initial)
<a name="l00356"></a>00356             : mField(initial)
<a name="l00357"></a>00357         {   }
<a name="l00358"></a>00358 
<a name="l00359"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a7f7b1b54d293173d8f7b7351f4f9d148">00359</a>         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1AtomicScalar.html">AtomicScalar&lt;T&gt;</a> &amp;cousin)
<a name="l00360"></a>00360             : mField(cousin.mField)
<a name="l00361"></a>00361         {   }
<a name="l00362"></a>00362 
<a name="l00363"></a><a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">00363</a>         <a class="code" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> ()
<a name="l00364"></a>00364         {   }
<a name="l00365"></a>00365 
<a name="l00366"></a><a class="code" href="classOgre_1_1AtomicScalar.html#add12daab3ff51fa24089269ab93100a5">00366</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AtomicScalar.html#add12daab3ff51fa24089269ab93100a5">operator= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AtomicScalar.html">AtomicScalar&lt;T&gt;</a> &amp;cousin)
<a name="l00367"></a>00367         {
<a name="l00368"></a>00368             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00369"></a>00369             mField = cousin.mField;
<a name="l00370"></a>00370         }
<a name="l00371"></a>00371 
<a name="l00372"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a0760f71192ec2403e8928d69f27e8ff0">00372</a>         T <span class="keyword">get</span> (void) <span class="keyword">const</span>
<a name="l00373"></a>00373         {
<a name="l00374"></a>00374             <span class="comment">// no lock required here</span>
<a name="l00375"></a>00375             <span class="comment">// since get will not interfere with set or cas</span>
<a name="l00376"></a>00376             <span class="comment">// we may get a stale value, but this is ok</span>
<a name="l00377"></a>00377             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00378"></a>00378         }
<a name="l00379"></a>00379 
<a name="l00380"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a18c86c571d84ca7daf21ff3e3265f886">00380</a>         <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> T &amp;v)
<a name="l00381"></a>00381         {
<a name="l00382"></a>00382             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00383"></a>00383             mField = v;
<a name="l00384"></a>00384         }
<a name="l00385"></a>00385 
<a name="l00386"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">00386</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">cas</a> (<span class="keyword">const</span> T &amp;old, <span class="keyword">const</span> T &amp;nu)
<a name="l00387"></a>00387         {
<a name="l00388"></a>00388             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00389"></a>00389             <span class="keywordflow">if</span> (mField != old) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00390"></a>00390             mField = nu;
<a name="l00391"></a>00391             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00392"></a>00392         }
<a name="l00393"></a>00393 
<a name="l00394"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">00394</a>         T <a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++ </a>(<span class="keywordtype">void</span>)
<a name="l00395"></a>00395         {
<a name="l00396"></a>00396             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00397"></a>00397             <span class="keywordflow">return</span> ++<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00398"></a>00398         }
<a name="l00399"></a>00399 
<a name="l00400"></a><a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">00400</a>         T <a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator-- </a>(<span class="keywordtype">void</span>)
<a name="l00401"></a>00401         {
<a name="l00402"></a>00402             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00403"></a>00403             <span class="keywordflow">return</span> --<a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00404"></a>00404         }
<a name="l00405"></a>00405 
<a name="l00406"></a><a class="code" href="classOgre_1_1AtomicScalar.html#ad45b625889810c679099fa85d7376cee">00406</a>         T <a class="code" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++ </a>(<span class="keywordtype">int</span>)
<a name="l00407"></a>00407         {
<a name="l00408"></a>00408             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00409"></a>00409             <span class="keywordflow">return</span> mField++;
<a name="l00410"></a>00410         }
<a name="l00411"></a>00411 
<a name="l00412"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a3aeaef070ff26d2920cc0cd2e48b1b1c">00412</a>         T <a class="code" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator-- </a>(<span class="keywordtype">int</span>)
<a name="l00413"></a>00413         {
<a name="l00414"></a>00414             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00415"></a>00415             <span class="keywordflow">return</span> mField--;
<a name="l00416"></a>00416         }
<a name="l00417"></a>00417 
<a name="l00418"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a582c7e533ac3485ca23d206a259b2860">00418</a>         T <a class="code" href="classOgre_1_1AtomicScalar.html#a582c7e533ac3485ca23d206a259b2860">operator+=</a>(<span class="keyword">const</span> T &amp;add)
<a name="l00419"></a>00419         {
<a name="l00420"></a>00420             <a class="code" href="OgrePrerequisites_8h.html#ace4a3180018d84c5295b17251233abfb">OGRE_LOCK_AUTO_MUTEX</a>
<a name="l00421"></a>00421             mField += add;
<a name="l00422"></a>00422             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00423"></a>00423         }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425         <span class="keyword">protected</span>:
<a name="l00426"></a>00426 
<a name="l00427"></a>00427         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00428"></a>00428 
<a name="l00429"></a><a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">00429</a>         <span class="keyword">volatile</span> T <a class="code" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a>;
<a name="l00430"></a>00430 
<a name="l00431"></a>00431     };
<a name="l00435"></a>00435 }
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 <span class="preprocessor">#endif</span>
<a name="l00438"></a>00438 <span class="preprocessor"></span>
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="preprocessor">#endif</span>
<a name="l00441"></a>00441 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
